#ifndef TESTTRANSPARENCYMASK_H_
#define TESTTRANSPARENCYMASK_H_

#include <cxxtest/TestSuite.h>

#include "TransparencyMask.h"
#include "ArrayRangeException.h"

class TestTransparencyMask : public CxxTest::TestSuite
{
public:
	void testTransparencyMask() {
		TransparencyMask tm;
		TS_ASSERT_EQUALS(tm.getWidth(), 40);
		TS_ASSERT_EQUALS(tm.getHeight(), 30);

		TransparencyMask* tm2 = new TransparencyMask(4, 3);
		TS_ASSERT_EQUALS(tm2->getWidth(), 4);
		TS_ASSERT_EQUALS(tm2->getHeight(), 3);
		delete tm2;
	}

	void testGetMaskValue() {
		TransparencyMask tm;
		TS_ASSERT_THROWS_NOTHING(tm.setMaskValue(3, 4, 56));
		TS_ASSERT_THROWS(tm.getMaskValue(3, 200), ArrayRangeException);
		TS_ASSERT_THROWS_NOTHING(tm.getMaskValue(3, 4));
		TS_ASSERT_EQUALS(tm.getMaskValue(3, 4), 56);
	}

	void testSetMaskValue() {
		TransparencyMask tm;
		TS_ASSERT_THROWS_NOTHING(tm.setMaskValue(3, 4, 56));
		TS_ASSERT_THROWS_NOTHING(tm.getMaskValue(3, 4));
		TS_ASSERT_EQUALS(tm.getMaskValue(3, 4), 56);
		TS_ASSERT_THROWS(tm.setMaskValue(3, 200, 56), ArrayRangeException);
	}

};

#endif /*TESTTRANSPARENCYMASK_H_*/
